package blusunrize.immersiveengineering.common.blocks.metal;

import blusunrize.immersiveengineering.ImmersiveEngineering;
import blusunrize.immersiveengineering.api.IEEnums.SideConfig;
import blusunrize.immersiveengineering.api.Lib;
import blusunrize.immersiveengineering.api.energy.immersiveflux.FluxStorage;
import blusunrize.immersiveengineering.api.tool.BelljarHandler;
import blusunrize.immersiveengineering.api.tool.BelljarHandler.FluidFertilizerHandler;
import blusunrize.immersiveengineering.api.tool.BelljarHandler.IPlantHandler;
import blusunrize.immersiveengineering.api.tool.BelljarHandler.ItemFertilizerHandler;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.client.models.IOBJModelCallback;
import blusunrize.immersiveengineering.common.Config.IEConfig;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IBlockBounds;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IDirectionalTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IGuiTile;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IHasDummyBlocks;
import blusunrize.immersiveengineering.common.blocks.TileEntityIEBase;
import blusunrize.immersiveengineering.common.util.EnergyHelper.IEForgeEnergyWrapper;
import blusunrize.immersiveengineering.common.util.EnergyHelper.IIEInternalFluxHandler;
import blusunrize.immersiveengineering.common.util.Utils;
import blusunrize.immersiveengineering.common.util.inventory.IEInventoryHandler;
import blusunrize.immersiveengineering.common.util.inventory.IIEInventory;
import blusunrize.immersiveengineering.common.util.network.MessageTileSync;
import com.google.common.base.Optional;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.renderer.texture.TextureAtlasSprite;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ITickable;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.model.TRSRTransformation;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidTank;
import net.minecraftforge.fluids.FluidUtil;
import net.minecraftforge.fluids.capability.CapabilityFluidHandler;
import net.minecraftforge.fml.common.network.NetworkRegistry.TargetPoint;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.ItemHandlerHelper;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class TileEntityBelljar extends TileEntityIEBase implements ITickable, IDirectionalTile, IBlockBounds, IHasDummyBlocks, IIEInventory, IIEInternalFluxHandler, IGuiTile, IOBJModelCallback<IBlockState>
{
	public EnumFacing facing = EnumFacing.NORTH;
	public int dummy = 0;
	private ItemStack[] inventory = new ItemStack[7];
	public FluidTank tank = new FluidTank(4000);
	public FluxStorage energyStorage = new FluxStorage(16000,Math.max(256,IEConfig.Machines.belljar_consumption));

	private IPlantHandler curPlantHandler;
	public int fertilizerAmount = 0;
	public float fertilizerMod = 1;
	private float growth = 0;
	public float renderGrowth = 0;

	@Override
	public void func_73660_a()
	{
		if(dummy!=0 || field_145850_b.func_175687_A(func_174877_v())>0)
			return;
		if(func_145831_w().field_72995_K)
		{
			if(energyStorage.getEnergyStored()>IEConfig.Machines.belljar_consumption && fertilizerAmount>0)
			{
				IPlantHandler handler = getCurrentPlantHandler();
				if(handler!=null&&handler.isCorrectSoil(inventory[1], inventory[0]) && fertilizerAmount>0)
				{
					if(renderGrowth<1)
					{
						renderGrowth += handler.getGrowthStep(inventory[1], inventory[0], renderGrowth, this, fertilizerMod, true);
						fertilizerAmount--;
					}
					else
						renderGrowth = handler.resetGrowth(inventory[1], inventory[0], renderGrowth, this, true);
					if(func_145831_w().field_73012_v.nextInt(8)==0)
					{
						double partX = func_174877_v().func_177958_n()+.5;
						double partY = func_174877_v().func_177956_o()+2.6875;
						double partZ = func_174877_v().func_177952_p()+.5;
						ImmersiveEngineering.proxy.spawnRedstoneFX(func_145831_w(), partX, partY, partZ, .25, .25, .25, 1f, .55f, .1f, .1f);
					}
				}
			}
		}
		else
		{
			if(inventory[1]!=null)
			{
				IPlantHandler handler = getCurrentPlantHandler();
				if(handler!=null&&handler.isCorrectSoil(inventory[1], inventory[0]) && fertilizerAmount>0 && energyStorage.extractEnergy(IEConfig.Machines.belljar_consumption, true)==IEConfig.Machines.belljar_consumption)
				{
					energyStorage.extractEnergy(IEConfig.Machines.belljar_consumption, false);
					fertilizerAmount--;
					if(growth >= 1)
					{
						ItemStack[] outputs = handler.getOutput(inventory[1], inventory[0], this);
						int canFit = 0;
						for(int i=0; i<outputs.length; i++)
							if(outputs[i]!=null)
								for(int j=3;j<7;j++)
									if(inventory[j]==null || (ItemHandlerHelper.canItemStacksStack(inventory[j],outputs[i]) && inventory[j].field_77994_a+outputs[i].field_77994_a<=inventory[j].func_77976_d()))
										canFit++;
						if(canFit>=outputs.length)
						{
							for(ItemStack output : outputs)
								for(int j=3;j<7;j++)
								{
									if(inventory[j]==null)
									{
										inventory[j] = output.func_77946_l();
										break;
									}
									else if(ItemHandlerHelper.canItemStacksStack(inventory[j], output)&&inventory[j].field_77994_a+output.field_77994_a <= inventory[j].func_77976_d())
									{
										inventory[j].field_77994_a += output.field_77994_a;
										break;
									}
								}
							growth = handler.resetGrowth(inventory[1], inventory[0], growth, this, false);
						}
					}
					else if(growth < 1)
					{
						growth += handler.getGrowthStep(inventory[1], inventory[0], growth, this, fertilizerMod, false);
						if(field_145850_b.func_82737_E()%32==((func_174877_v().func_177958_n()^func_174877_v().func_177952_p())&32))
							sendSyncPacket(0);
					}
				}
				else
					growth = 0;

				if(fertilizerAmount<=0 && tank.getFluidAmount()>IEConfig.Machines.belljar_fluid)
				{
					FluidFertilizerHandler fluidFert = BelljarHandler.getFluidFertilizerHandler(tank.getFluid());
					if(fluidFert!=null)
					{
						fertilizerMod = fluidFert.getGrowthMultiplier(tank.getFluid(), inventory[1],inventory[0], this);
						tank.drain(IEConfig.Machines.belljar_fluid, true);
						if(inventory[2]!=null)
						{
							ItemFertilizerHandler itemFert = BelljarHandler.getItemFertilizerHandler(inventory[2]);
							if(itemFert!=null)
								fertilizerMod *= itemFert.getGrowthMultiplier(inventory[2], inventory[1], inventory[0], this);
							inventory[2].field_77994_a--;
							if(inventory[2].field_77994_a<=0)
								inventory[2]=null;
						}
						fertilizerAmount = IEConfig.Machines.belljar_fertilizer;
						sendSyncPacket(1);
					}
				}
			}
			else
				growth = 0;

			if(field_145850_b.func_82737_E()%8==0)
			{
				BlockPos outputPos = func_174877_v().func_177984_a().func_177972_a(facing.func_176734_d());
				TileEntity outputTile = this.field_145850_b.func_175625_s(outputPos);
				if(outputTile!=null)
					for(int j=3; j<7; j++)
						if(inventory[j]!=null)
						{
							int out = Math.min(inventory[j].field_77994_a, 16);
							ItemStack stack = Utils.copyStackWithAmount(inventory[j], out);
							stack = Utils.insertStackIntoInventory(outputTile, stack, facing);
							if(stack != null)
								out -= stack.field_77994_a;
							if((this.inventory[j].field_77994_a -= out) <= 0)
								this.inventory[j] = null;
						}
			}
		}
	}

	public IPlantHandler getCurrentPlantHandler()
	{
		if(curPlantHandler==null || !curPlantHandler.isValid(inventory[1]))
			curPlantHandler = BelljarHandler.getHandler(inventory[1]);
		return curPlantHandler;
	}

	protected void sendSyncPacket(int type)
	{
		NBTTagCompound nbt = new NBTTagCompound();
		if(type==0)
			nbt.func_74776_a("growth", growth);
		else if(type==1)
		{
			nbt.func_74768_a("fertilizerAmount", fertilizerAmount);
			nbt.func_74776_a("fertilizerMod", fertilizerMod);
		}
		else if(type==2)
			nbt.func_74782_a("tank", tank.writeToNBT(new NBTTagCompound()));
		ImmersiveEngineering.packetHandler.sendToAllAround(new MessageTileSync(this, nbt), new TargetPoint(func_145831_w().field_73011_w.getDimension(),func_174877_v().func_177958_n(),func_174877_v().func_177956_o(),func_174877_v().func_177952_p(), 128));
	}
	@Override
	public void receiveMessageFromServer(NBTTagCompound message)
	{
		if(message.func_74764_b("growth"))
			renderGrowth = message.func_74760_g("growth");
		if(message.func_74764_b("fertilizerAmount"))
			fertilizerAmount = message.func_74762_e("fertilizerAmount");
		if(message.func_74764_b("fertilizerMod"))
			fertilizerMod = message.func_74760_g("fertilizerMod");
		if(message.func_74764_b("tank"))
			tank.readFromNBT(message.func_74775_l("tank"));
	}

	@Override
	public void readCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		facing = EnumFacing.func_82600_a(nbt.func_74762_e("facing"));
		dummy = nbt.func_74762_e("dummy");
		inventory = Utils.readInventory(nbt.func_150295_c("inventory",10),7);
		energyStorage.readFromNBT(nbt);
		tank.readFromNBT(nbt.func_74775_l("tank"));
		fertilizerAmount = nbt.func_74762_e("fertilizerAmount");
		fertilizerMod = nbt.func_74760_g("fertilizerMod");
		growth = nbt.func_74760_g("growth");
	}

	@Override
	public void writeCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		nbt.func_74768_a("facing", facing.ordinal());
		nbt.func_74768_a("dummy", dummy);
		nbt.func_74782_a("inventory", Utils.writeInventory(inventory));
		energyStorage.writeToNBT(nbt);
		NBTTagCompound tankTag = tank.writeToNBT(new NBTTagCompound());
		nbt.func_74782_a("tank", tankTag);
		nbt.func_74768_a("fertilizerAmount", fertilizerAmount);
		nbt.func_74776_a("fertilizerMod", fertilizerMod);
		nbt.func_74776_a("growth", growth);
	}

	@Override
	public EnumFacing getFacing()
	{
		return facing;
	}
	@Override
	public void setFacing(EnumFacing facing)
	{
		this.facing = facing;
	}
	@Override
	public int getFacingLimitation()
	{
		return 2;
	}
	@Override
	public boolean mirrorFacingOnPlacement(EntityLivingBase placer)
	{
		return false;
	}
	@Override
	public boolean canHammerRotate(EnumFacing side, float hitX, float hitY, float hitZ, EntityLivingBase entity)
	{
		return true;
	}
	@Override
	public boolean canRotate(EnumFacing axis)
	{
		return true;
	}

	@Override
	public float[] getBlockBounds()
	{
		return null;//new float[]{facing==EnumFacing.EAST?0:.25f,facing==EnumFacing.UP?0:facing==EnumFacing.DOWN?.125f:.0625f,facing==EnumFacing.SOUTH?0:.25f, facing==EnumFacing.WEST?1:.75f,facing==EnumFacing.DOWN?1:.875f,facing==EnumFacing.NORTH?1:.75f};
	}

	@Override
	public boolean isDummy()
	{
		return dummy!=0;
	}
	@Override
	public void placeDummies(BlockPos pos, IBlockState state, EnumFacing side, float hitX, float hitY, float hitZ)
	{
		for(int i=1; i<=2; i++)
		{
			field_145850_b.func_175656_a(pos.func_177981_b(i), state);
			((TileEntityBelljar)field_145850_b.func_175625_s(pos.func_177981_b(i))).dummy = i;
			((TileEntityBelljar)field_145850_b.func_175625_s(pos.func_177981_b(i))).facing = facing;
		}
	}
	@Override
	public void breakDummies(BlockPos pos, IBlockState state)
	{
		for(int i=0; i<=2; i++)
		{
			BlockPos p = func_174877_v().func_177979_c(dummy).func_177981_b(i);
			if(field_145850_b.func_175625_s(p) instanceof TileEntityBelljar)
				field_145850_b.func_175698_g(p);
		}
	}

	@Override
	public ItemStack[] getInventory()
	{
		return inventory;
	}
	@Override
	public boolean isStackValid(int slot, ItemStack stack)
	{
		return true;
	}
	@Override
	public int getSlotLimit(int slot)
	{
		return slot<2?1:64;
	}
	@Override
	public void doGraphicalUpdates(int slot)
	{
		if(slot==0)
		{
			this.func_70296_d();
			this.markContainingBlockForUpdate(null);
		}
	}


	@Override
	public boolean hasCapability(Capability<?> capability, EnumFacing facing)
	{
		if(capability==CapabilityItemHandler.ITEM_HANDLER_CAPABILITY)
			return dummy==0?(facing==null||facing.func_176740_k()!=this.facing.func_176746_e().func_176740_k()): dummy==1&&(facing==null||facing==this.facing.func_176734_d());
		else if(capability==CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY)
			return dummy==0 && (facing==null||facing.func_176740_k()!=this.facing.func_176746_e().func_176740_k());
		return super.hasCapability(capability, facing);
	}
	IItemHandler inputHandler = new IEInventoryHandler(1,this,2, true,false);
	IItemHandler outputHandler = new IEInventoryHandler(4,this,3, false,true);
	@Override
	public <T> T getCapability(Capability<T> capability, EnumFacing facing)
	{
		if(capability==CapabilityItemHandler.ITEM_HANDLER_CAPABILITY)
		{
			if(dummy==0 && (facing==null||facing.func_176740_k()!=this.facing.func_176746_e().func_176740_k()))
				return (T)inputHandler;
			if(dummy==1 && (facing==null||facing==this.facing.func_176734_d()))
				return (T)outputHandler;
		}
		else if(capability==CapabilityFluidHandler.FLUID_HANDLER_CAPABILITY && dummy==0 && (facing==null||facing.func_176740_k()!=this.facing.func_176746_e().func_176740_k()))
			return (T)tank;
		return super.getCapability(capability, facing);
	}

	@Override
	public boolean canOpenGui()
	{
		return true;
	}
	@Override
	public int getGuiID()
	{
		return Lib.GUIID_Belljar;
	}
	@Override
	public TileEntity getGuiMaster()
	{
		if(dummy==0)
			return this;
		TileEntity te = field_145850_b.func_175625_s(func_174877_v().func_177979_c(dummy));
		if(te instanceof TileEntityBelljar)
			return te;
		return null;
	}


	@Override
	@SideOnly(Side.CLIENT)
	public TextureAtlasSprite getTextureReplacement(IBlockState object, String material)
	{
		if(inventory[0]!=null && "farmland".equals(material))
		{
			ResourceLocation rl = getSoilTexture();
			if(rl!=null)
				return ClientUtils.getSprite(rl);
		}
		return null;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public boolean shouldRenderGroup(IBlockState object, String group)
	{
		return !"extension".equals(group) ;//&& !"base_glass".equals(group);
	}
	@Override
	@SideOnly(Side.CLIENT)
	public Optional<TRSRTransformation> applyTransformations(IBlockState object, String group, Optional<TRSRTransformation> transform)
	{
		return transform;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public String getCacheKey(IBlockState object)
	{
		if(inventory[0]!=null)
		{
			ResourceLocation rl = getSoilTexture();
			if(rl!=null)
				return rl.toString();
		}
		return null;
	}
	@SideOnly(Side.CLIENT)
	private ResourceLocation getSoilTexture()
	{
		ResourceLocation rl = curPlantHandler!=null?curPlantHandler.getSoilTexture(inventory[1], inventory[0], this):null;
		if(rl==null)
			rl=BelljarHandler.getSoilTexture(inventory[0]);
		if(rl==null)
		{
			IBlockState state = Utils.getStateFromItemStack(inventory[0]);
			if(state!=null)
				rl = ClientUtils.getSideTexture(state, EnumFacing.UP);
		}
		if(rl==null && inventory[0]!=null && Utils.isFluidRelatedItemStack(inventory[0]))
		{
			FluidStack fs = FluidUtil.getFluidContained(inventory[0]);
			if(fs!=null)
				rl = fs.getFluid().getStill(fs);
		}
		return rl;
	}

	@Nonnull
	@Override
	public FluxStorage getFluxStorage()
	{
		if(dummy!=0)
		{
			TileEntity te = field_145850_b.func_175625_s(func_174877_v().func_177979_c(dummy));
			if(te instanceof TileEntityBelljar)
				return ((TileEntityBelljar)te).energyStorage;
		}
		return this.energyStorage;
	}
	@Nonnull
	@Override
	public SideConfig getEnergySideConfig(@Nullable EnumFacing facing)
	{
		return facing==null||(dummy==0&&facing.func_176740_k()==this.facing.func_176746_e().func_176740_k())||(dummy==2&&facing==EnumFacing.UP)?SideConfig.INPUT:SideConfig.NONE;
	}
	IEForgeEnergyWrapper energyWrapper = new IEForgeEnergyWrapper(this, EnumFacing.UP);
	@Override
	public IEForgeEnergyWrapper getCapabilityWrapper(EnumFacing facing)
	{
		if(facing==null||(dummy==0&&facing.func_176740_k()==this.facing.func_176746_e().func_176740_k())||(dummy==2&&facing==EnumFacing.UP))
			return energyWrapper;
		return null;
	}
}
